SystemOrganization addCategory: #'SourceCity-Tools'!

StandardWindow subclass: #SourceCityUI
	instanceVariableNames: 'window informationDisplay cityInformation sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!SourceCityUI commentStamp: '<historical>' prior: 0!
I am the window where you can watch source City, i also have some buttons and stuff for documentation picking!

!SourceCityUI class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/24/2012 13:19'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 15:36'!
addAll
	self addMorph: self sourceCityGL
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.5));
		addMorph: self downPanel
		fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 13:45'!
buildInformation
	^(self newTitle: 'Picking information' for: (
		(self newTextEditorFor: cityInformation
			getText: #contents
			setText: #contents:) 
		disable;minWidth: 100;
		minHeight: 50)
		).! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 15:53'!
buttons

	^  (self newRow: {
		self newButtonFor: self sourceCityGL camera action: #cameraOnTop label: 'Top view' help: ''.
		self newButtonFor: self sourceCityGL camera action: #cameraOnNormal label: 'Normal view' help: ''
		})! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 17:23'!
cityInformation
	^ cityInformation contents! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 12:10'!
cityInformation: anObject
	cityInformation := anObject.! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:43'!
citySetInformation: anObject
	cityInformation contents: anObject asString! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 15:55'!
downPanel
	^  (	 self newColumn: {
			(self newRow: {self buttons}).
			(self newRow: { self buildInformation }) vResizing: #spaceFill.
			}).! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 12:09'!
getInformation
	(self sourceCityGL selectedElement isNil)
	ifTrue: [self citySetInformation: ''] 
	ifFalse: [self citySetInformation: self  sourceCityGL selectedElement].! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/25/2012 10:33'!
information
	^(self newTitle: 'Picking information' for: (
		(self newTextEditorFor: cityInformation
			getText: #contents
			setText: #contents:) 
		disable;minWidth: 100;
		minHeight: 50)
		).! !

!SourceCityUI methodsFor: 'initialize' stamp: 'DouailleErwan 7/2/2012 12:10'!
initialize
	super initialize.
	self cityInformation: (ValueHolder new contents: '').! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/24/2012 19:27'!
menu! !

!SourceCityUI methodsFor: 'initialize' stamp: 'DouailleErwan 7/2/2012 16:12'!
openInWorld
	| container |
	self addAll.
	super openInWorld.
	self themeChanged;
		title: 'SourceCity: ', self sourceCityGL importer city model asString;
		width: 700;
		height: 500! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/25/2012 10:33'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:44'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:12'!
window
	^ window! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:12'!
window: anObject
	window := anObject! !

Object subclass: #CityVisualization
	instanceVariableNames: 'buildingGap buildingHighColor buildingLowColor buildingMaxHeightColor buildingMaxWidthColor cameraXPos cameraYPos cameraZPos cityColor districtColor districtGap glBackground listPackages openGL win model buildingMediumHeightColor buildingMediumColor glCity configurationClass unselectedSelectionList unselectedItems unselectedSelectionIndex selectedSelectionList selectedItems selectedSelectionIndex buildingHeightCalcList buildingWidthCalcList glAAList glPerspectiveList multiImporterPackage multiImporterClassSelector visualizationList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!CityVisualization commentStamp: '<historical>' prior: 0!
Tool for easily configure your own visualization!

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingGap
	^ buildingGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingGap: anObject
	buildingGap := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingHeightCalcList
	^ buildingHeightCalcList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingHeightCalcList: anObject
	buildingHeightCalcList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingHighColor
	^ buildingHighColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingHighColor: anObject
	buildingHighColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingLowColor
	^ buildingLowColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingLowColor: anObject
	buildingLowColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 6/7/2012 14:41'!
buildingMaxHeightCalcColor: anObject
	((self buildingHeightCalcList selectedItem asSymbol) asString = 'none')
	ifTrue: [
		^ (anObject).
		] 
	ifFalse: [
		^ (anObject perform: (self buildingHeightCalcList selectedItem asSymbol))*2.
		].! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMaxHeightColor
	^ buildingMaxHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMaxHeightColor: anObject
	buildingMaxHeightColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMaxWidthColor
	^ buildingMaxWidthColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMaxWidthColor: anObject
	buildingMaxWidthColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMediumColor
	^ buildingMediumColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMediumColor: anObject
	buildingMediumColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 6/7/2012 14:41'!
buildingMediumHeightCalcColor: anObject
	((self buildingHeightCalcList selectedItem asSymbol) asString = 'none')
	ifTrue: [
		^ (anObject).
		] 
	ifFalse: [
		^ (anObject perform: (self buildingHeightCalcList selectedItem asSymbol))*2.
		].! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMediumHeightColor
	^ buildingMediumHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingMediumHeightColor: anObject
	buildingMediumHeightColor := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
buildingTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
					(win newTitle: 'Low color' for: (((buildingLowColor) minHeight: 80; minWidth: 120))).
					(win newTitle: 'Medium color' for: (((buildingMediumColor) minHeight: 80; minWidth: 120))).
					(win newTitle: 'High color' for: ((buildingHighColor) minHeight: 80; minWidth: 120))
					}.
				win newGroupbox: 'Value settings' forAll:{
					(win newTitle: 'Gap between each building' for: (
						(win newTextEntryFor:  (buildingGap)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'Medium selector size by building' for: (
						(win newTextEntryFor:  (buildingMediumHeightColor)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'Max selector size by building' for: (
						(win newTextEntryFor:  (buildingMaxHeightColor)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
				}.
				win newGroupbox: 'Size settings' forAll:{
					(win newTitle: 'Building height calculator' for: (
						(win newDropListFor: (buildingHeightCalcList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					(win newTitle: 'Building width calculator' for: (
						(win newDropListFor: (buildingWidthCalcList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
				}.
			})! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingWidthCalcList
	^ buildingWidthCalcList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
buildingWidthCalcList: anObject
	buildingWidthCalcList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cameraXPos
	^ cameraXPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cameraXPos: anObject
	cameraXPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cameraYPos
	^ cameraYPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cameraYPos: anObject
	cameraYPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cameraZPos
	^ cameraZPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cameraZPos: anObject
	cameraZPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cityColor
	^ cityColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
cityColor: anObject
	cityColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 6/7/2012 20:51'!
cityConfigurationBuild
	|config tmp packages selector |
	
	tmp := CityImporter new.
	tmp cityNamed: 'CodCT' withPackageNames: (visualizationList selectedItems) widthSelectorChoice: (self buildingWidthCalcList selectedItem asSymbol) heightSelectorChoice: (self buildingHeightCalcList selectedItem asSymbol) colorMediumSelector: self buildingMediumHeightColor contents asInteger colorHighSelector: self buildingMaxHeightColor contents asInteger colorLow: self buildingLowColor selectedColor colorMedium: self buildingMediumColor selectedColor colorHigh: self buildingHighColor selectedColor.
	
	"tmp := CityMultiImporter new.
	tmp cityNamed: 'CodCT' withPackageNames: (self multiImporterPackage) withClassSelector: (self multiImporterClassSelector) widthSelectorChoice: (self buildingWidthCalcList selectedItem asSymbol) heightSelectorChoice: (self buildingHeightCalcList selectedItem asSymbol) colorMediumSelector: self buildingMediumHeightColor contents asInteger colorHighSelector: self buildingMaxHeightColor contents asInteger colorLow: self buildingLowColor selectedColor colorMedium: self buildingMediumColor selectedColor colorHigh: self buildingHighColor selectedColor."

	self model: tmp.
	config := CityConfiguration new.
	^config cityColor: self cityColor selectedColor;
		districtColor: self districtColor selectedColor;
		districtGap: self districtGap contents asInteger;
		buildingLowColor: self buildingLowColor selectedColor;
		buildingMediumColor: self buildingMediumColor selectedColor;	
		buildingHighColor: self buildingHighColor selectedColor;	
		buildingGap: self buildingGap contents asInteger;
		buildingMediumHeightColor: (self buildingMediumHeightCalcColor: (self buildingMediumHeightColor contents asInteger));
		buildingMaxHeightColor: (self buildingMaxHeightCalcColor: (self buildingMaxHeightColor contents asInteger));
		buildingMaxWidthColor: self buildingMaxWidthColor contents asInteger;
		buildingHeightCalcList: self buildingHeightCalcList selectedItem asString;
		buildingWidthCalcList: self buildingWidthCalcList selectedItem asString;
		glBackground: self glBackground selectedColor ;
		glAAList: self glAAList selectedItem asString;
		glPerspectiveList: self glPerspectiveList selectedItem asString;
		cameraXPos: self cameraXPos contents asInteger;
		cameraYPos: self cameraYPos contents asInteger;
		cameraZPos: self cameraZPos contents asInteger;
		model: self model.! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
cityTab
		^(win newTitle: 'City color' for: (
				(cityColor) minHeight: 80; minWidth: 120;vResizing: #spaceFill))! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
components
	^(win newTabGroup: {
			(win newRow: {
				win newImage: PharoTheme newDefault smallConfigurationIcon . 
				win newLabel: 'Importer configuration'	})->
				(win newGroupbox: 'Select packages to visualize' forAll: { self packageTab}).
				'City settings'->(self cityTab).
				'Districts settings'->(self districtTab).
				'Buildings settings'->(self buildingTab).
				'OpenGL view settings'->(self openGLTab).
				})
			! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
configurationClass
	^ configurationClass! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
configurationClass: anObject
	configurationClass := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
display
	|dock container |
		dock := win newToolDockingBar.
		dock
			addMorph: self toolbar.
			
		container := PanelMorph new.
		container 
			changeTableLayout; 
			listDirection: #rigthToLeft.
		container addMorph: self components.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			addMorph: container
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			title: 'SourceCity Configuration';
			openInWorld;
			width: 800;
			height: 500.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
districtColor
	^ districtColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
districtColor: anObject
	districtColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
districtGap
	^ districtGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
districtGap: anObject
	districtGap := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
districtTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
						(win newTitle: 'District color' for: ((districtColor) minHeight: 80; minWidth: 120)).
					}.
				win newGroupbox: 'Size settings' forAll:{
						(win newTitle: 'Gap between each district' for: (
							(win newTextEntryFor:  (districtGap)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
					}
				})! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glAAList
	^ glAAList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glAAList: anObject
	glAAList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glBackground
	^ glBackground! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glBackground: anObject
	glBackground := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glCity
	^ glCity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glCity: anObject
	glCity := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glPerspectiveList
	^ glPerspectiveList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
glPerspectiveList: anObject
	glPerspectiveList := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
helpDisplay
	|dialog builder window|
	window := UITheme .
	builder := window exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Help !!') useDefaultOKButton.
	dialog contentMorph: (
		(dialog newRow: {
				(dialog newTextEditorFor: (ValueHolder new contents: 'SourceCity Information',Character cr asString,'Shortcut keyboard :') 
				getText: #contents 
				setText: #contents:) minWidth: 300;minHeight: 600;disable .
			})vResizing: #spaceFill); model: nil.
	builder openModal: dialog! !

!CityVisualization methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/7/2012 15:31'!
initialize
	win := StandardWindow new.
	multiImporterPackage := ValueHolder new contents: ''.
	multiImporterClassSelector := ValueHolder new contents: ''.
	buildingMaxWidthColor := ValueHolder new contents: '5'.
	cityColor := win newHSVSelector: (Color r: 0.6 g: 0.6 b: 0.6) 
		help: 'This is a hue-saturation-volume selector'.
	districtColor := win newHSVSelector: (Color r: 0.8 g: 0.8 b: 0.8)
		help: 'This is a hue-saturation-volume selector'.
	districtGap := ValueHolder new contents: '2'.
	buildingLowColor := win newHSVSelector: (Color green)
		help: 'This is a hue-saturation-volume selector'.
	buildingMediumColor := win newHSVSelector: (Color  orange)
		help: 'This is a hue-saturation-volume selector'.
	buildingHighColor := win newHSVSelector: (Color  red)
		help: 'This is a hue-saturation-volume selector'.
	buildingGap := ValueHolder new contents: '2'.
	buildingMediumHeightColor := ValueHolder new contents: '20'.
	buildingMaxHeightColor := ValueHolder new contents: '50'.
	buildingMaxWidthColor := ValueHolder new contents: '5'.
	buildingHeightCalcList := ListModel new list: #('sqrt' 'ln' 'log' 'none');selectionIndex:2.
	buildingWidthCalcList := ListModel new list: #('sqrt' 'ln' 'log' 'none');selectionIndex:2.
	glBackground := win newHSVSelector: (Color r: 1 g: 1 b: 1)
		help: 'This is a hue-saturation-volume selector'.
	glAAList := ListModel new list: #('FASTEST' 'NICEST');selectionIndex:1.
	glPerspectiveList := ListModel new list: #('FASTEST' 'NICEST');selectionIndex:1.
	cameraXPos := ValueHolder new contents: '-196'.
	cameraYPos := ValueHolder new contents: '-15'.
	cameraZPos := ValueHolder new contents: '0'.
	self display! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
listPackages
	^ listPackages! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
listPackages: anObject
	listPackages := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
model
	^ model! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
model: anObject
	model := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
multiImporterClassSelector
	^ multiImporterClassSelector! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
multiImporterClassSelector: anObject
	multiImporterClassSelector := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
multiImporterPackage
	^ multiImporterPackage! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
multiImporterPackage: anObject
	multiImporterPackage := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
openGL
	^ openGL! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
openGL: anObject
	openGL := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
openGLTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
					(win newTitle: 'Background color' for: ((glBackground) minHeight: 80; minWidth: 120)).}.
					win newGroupbox: 'Camera default position settings' forAll:{
					(win newTitle: 'x' for: (
						(win newTextEntryFor:  (cameraXPos)
							getText: #contents
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'y' for: (
						(win newTextEntryFor:  (cameraYPos)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'z' for: (
						(win newTextEntryFor:  (cameraZPos)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
				}.
				win newGroupbox: 'OpenGL environment settings DO NOT WORK' forAll:{
					(win newTitle: 'Enable/disable Light' for: (
						(win newCheckboxFor: (ValueHolder new contents: true)
						getSelected: #contents setSelected: #contents: label: 'Light' help: 'This is a checkbox'))).
					(win newTitle: 'Enable/disable Light' for: (
						(win newCheckboxFor: (ValueHolder new contents: true)
						getSelected: #contents setSelected: #contents: label: 'Shadow' help: 'This is a checkbox'))).
					(win newTitle: 'Anti analysing performance' for: (
						(win newDropListFor: (glAAList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					(win newTitle: 'Perspective performance' for: (
						(win newDropListFor: (glPerspectiveList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					}
				})! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 16:54'!
packageTab
		visualizationList := CityVisualizationItemList new. "initialize: PackageInfo allPackages."
		^(win newRow:{
				win newGroupbox: 'Unselected packages' for: (win newColumn: {
						visualizationList buildUnselectedItemsList.}).
				(win newGroupboxFor: (
					(win newColumn: {
						visualizationList buildAddAllButton.
						visualizationList buildAddButton.
						visualizationList buildRemoveButton.
						visualizationList buildRemoveAllButton})
						vResizing: #shrinkWrap))
					vResizing: #shrinkWrap.
				win newGroupbox: 'Selected packages' for: (win newColumn: {
						visualizationList buildSelectedItemsList.}).
				})vResizing: #spaceFill;hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 6/7/2012 14:41'!
refreshActivity
	(glCity isNil)
	ifFalse: [
		glCity changeConfiguration: self cityConfigurationBuild.
		].
	! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
selectedItems
	^ selectedItems! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
selectedItems: anObject
	selectedItems := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
selectedSelectionIndex
	^ selectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
selectedSelectionIndex: anObject
	selectedSelectionIndex := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
selectedSelectionList
	^ selectedSelectionList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
selectedSelectionList: anObject
	selectedSelectionList := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 6/7/2012 14:41'!
startActivity
	glCity := GLCity new default: self cityConfigurationBuild ;openInWorld.! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 6/7/2012 14:41'!
toolbar
	^win newToolbar: {
		win newButtonFor: self 
			getState:  nil
			action:  #startActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallDoItIcon 
			help:'Start City view' .
		win newButtonFor: self 
			getState:  nil
			action:  #refreshActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallUpdateIcon 
			help:'Change current configuration' .
			}.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
unselectedItems
	^ unselectedItems! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
unselectedItems: anObject
	unselectedItems := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
unselectedSelectionIndex
	^ unselectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
unselectedSelectionIndex: anObject
	unselectedSelectionIndex := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
unselectedSelectionList
	^ unselectedSelectionList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
unselectedSelectionList: anObject
	unselectedSelectionList := anObject! !

!CityVisualization methodsFor: 'updating' stamp: 'DouailleErwan 6/7/2012 14:41'!
update: aSymbol 
	self refreshActivity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
visualizationList
	^ visualizationList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
visualizationList: anObject
	visualizationList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
win
	^ win! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 6/7/2012 22:45'!
win: anObject
	win := anObject! !

Object subclass: #CityVisualizationItemList
	instanceVariableNames: 'unselectedSelectionList win selectedSelectionList selectedItems selectedSelectionIndex unselectedSelectionIndex unselectedItems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!CityVisualizationItemList commentStamp: '<historical>' prior: 0!
Item list at the first tab of CityViusalisation!

!CityVisualizationItemList class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/15/2012 13:17'!
default
	^ self new initialize: PackageInfo allPackages! !

!CityVisualizationItemList class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/15/2012 13:14'!
defaultRPackage
	^ self new initialize.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:45'!
addAllButtonAction
	self addAllItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:46'!
addAllButtonState
	^false! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:46'!
addAllItems
	self selectedItems addAll: self unselectedItems.
	self unselectedItems removeAll.
	unselectedSelectionList removeAll.
	self unselectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:46'!
addButtonAction
	self addSelectedItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:46'!
addButtonState
	^false! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
addSelectedItems

	self selectedItems addAll: self unselectedSelectionItems..
	self unselectedItems removeAll:  self unselectedSelectionItems..
	unselectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
buildAddAllButton
	^(win
		newButtonFor: self
		getState: #addAllButtonState
		action: #addAllButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedItems
		label: '>>'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
buildAddButton
	^(win
		newButtonFor: self
		getState: #addButtonState
		action: #addButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedSelections
		label: '>'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
buildRemoveAllButton
	^(win
		newButtonFor: self
		getState: #removeAllButtonState
		action: #removeAllButtonAction
		arguments: nil
		getEnabled: #hasSelectedItems
		label: '<<'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
buildRemoveButton
	^(win
		newButtonFor: self
		getState: #removeButtonState
		action: #removeButtonAction 
		arguments: nil
		getEnabled: #hasSelectedSelections
		label: '<'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:48'!
buildSelectedItemsList
	^(PluggableListMorph
		on: self 
		list: #selectedItems
		primarySelection: #selectedSelectionIndex
		changePrimarySelection: #selectedSelectionIndex:
		listSelection: #selectedSelectionAt:
		changeListSelection: #selectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
buildUnselectedItemsList
	^(PluggableListMorph
		on: self 
		list: #unselectedItems
		primarySelection: #unselectedSelectionIndex
		changePrimarySelection: #unselectedSelectionIndex:
		listSelection: #unselectedSelectionAt:
		changeListSelection: #unselectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:48'!
hasSelectedItems
	"Answer whether the selected list has items."

	^self selectedItems notEmpty! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:48'!
hasSelectedSelections
	"Answer whether the selected list has selected items."

	^selectedSelectionList anySatisfy: [:selected | selected]! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
hasUnselectedItems
	^self unselectedItems notEmpty! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
hasUnselectedSelections
	"Answer whether the unselected list has selected items."

	^unselectedSelectionList anySatisfy: [:selected | selected]! !

!CityVisualizationItemList methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/7/2012 15:19'!
initialize
	self initialize: ((RPackageOrganizer default packageNames) sort: [:a :b | a name < b name]).! !

!CityVisualizationItemList methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/7/2012 15:20'!
initialize: anArray
	|tmp|
	tmp :=OrderedCollection new.
	tmp addAll: anArray.
	self unselectedItems: OrderedCollection new.
	self selectedItems: tmp.
	selectedSelectionList := Dictionary new.
	unselectedSelectionList := Dictionary new.
	win := StandardWindow new.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
removeAllButtonAction
	self removeAllItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
removeAllButtonState
	^false! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:47'!
removeAllItems
	self unselectedItems addAll: self selectedItems.
	self selectedItems removeAll.
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:48'!
removeButtonAction
	self removeSelectedItems.! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:48'!
removeButtonState
	^false! !

!CityVisualizationItemList methodsFor: 'action-list' stamp: 'DouailleErwan 6/7/2012 14:48'!
removeSelectedItems
	self unselectedItems addAll:  self selectedSelectionItems..
	self selectedItems removeAll: self selectedSelectionItems..
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:49'!
selectedItems
	^selectedItems! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:49'!
selectedItems: anOrderedCollection 
	
	selectedItems := anOrderedCollection.! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:49'!
selectedSelectionAt: index

	^selectedSelectionList at: index ifAbsent: [false]! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 15:07'!
selectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	selectedSelectionList at: index put: aBoolean.
	self changed: #hasSelectedSelections! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:49'!
selectedSelectionIndex
	selectedSelectionIndex ifNil: [selectedSelectionIndex := 0].
	^selectedSelectionIndex! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:50'!
selectedSelectionIndex: anObject
	selectedSelectionIndex := anObject.
	self changed: #selectedSelectionIndex! !

!CityVisualizationItemList methodsFor: 'selected-list' stamp: 'DouailleErwan 6/7/2012 14:50'!
selectedSelectionItems
	| result |
	result := OrderedCollection new.
	self selectedItems doWithIndex: [:item :index |
		(self selectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
unselectedItems
	^unselectedItems! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:57'!
unselectedItems: anOrderedCollection 
	
	unselectedItems := anOrderedCollection. ! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
unselectedSelectionAt: index

	^unselectedSelectionList at: index ifAbsent: [false]! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
unselectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	unselectedSelectionList at: index put: aBoolean.
	self changed: #hasUnselectedSelections! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
unselectedSelectionIndex
	unselectedSelectionIndex ifNil: [unselectedSelectionIndex := 0].
	^unselectedSelectionIndex! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:57'!
unselectedSelectionIndex: anObject

	unselectedSelectionIndex := anObject.
	self changed: #unselectedSelectionIndex ! !

!CityVisualizationItemList methodsFor: 'unselected-list' stamp: 'DouailleErwan 6/7/2012 14:41'!
unselectedSelectionItems

	| result |
	result := OrderedCollection new.
	self unselectedItems doWithIndex: [:item :index |
		(self unselectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

Object subclass: #SourceCityRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!SourceCityRenderer commentStamp: '<historical>' prior: 0!
This class is the main class if you want to have some visualisation. You put on it the parameters and everything could be launch!

!SourceCityRenderer class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/2/2012 14:34'!
default
	SourceCityGL new 
		sourceCityApi: (SourceCityApi default sourceCityImporter: 
			(SourceCityRPackageImporter title: 'Default view of SourceCity' 
				strategy: SourceCityImporterASTCoreRpackageStrategy 
				new import: #('AST-Core' 'AST-Core-Matching' 'AST-Core-Nodes' 'AST-Core-Parser' 'AST-Core-Pattern' 'AST-Core-Tokens' 'AST-Core-Visitors' )
				));
		openInWorld.! !

!SourceCityRenderer class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/2/2012 14:33'!
sourceCityApi: aSourceCityApi
	SourceCityGL new 
		sourceCityApi: aSourceCityApi;
		openInWorld.! !
